#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "mainprocess4Xi.py">
#<abstract4xi abstract = "provides MainProcess4Xi class"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MainProcess4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import tempfile
except:
    pass
try:                 # rare ones
    from functools import partial           
except:
    pass 
try:                 # imported-as ones 
    pass           
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import _MainProcess
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi 

from current_process4xi import add_child_current_process4xi
from current_process4xi import get_current_process4xi

from examine4xi import examine4xi

from popen4xi import Popen4Xi
from print4xi import print4xi

from reason_object4xi import reason_object4xi

from sense_object4xi import sense_object4xi

from timeout4xi import omega2timeout4xi    
from time4xi import time4xi                 

#"
#/>


  
# =================================================================================================
#<class4xi class = "MainProcess4Xi" base = "object" child = "None" synopsis = "creates object representing the main process" usage = "
#
#   current_process4xi.py
#       _current_process = MainProcess4Xi()
# 
#   process.py
#       _MainProcess(Process)
#           _current_process = _MainProcess() 
#           del _MainProcess
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class MainProcess4Xi(object): # does NOT and can NOT inherit from Process4Xi! 
                              # therefore this class must should have the same methods as Process4Xi coded
    '''
    MainProcess4Xi class creates object representing the main process
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('run', 'start',
                 'is_alive', 'join', 'terminate',
                 'sense', 'reason', 'ace',)          
    #"
    #/>
                                                                                                                                                                    

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    _Popen = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MainProcess4Xi" usage = "initializes MainProcess4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
                
        # -----------------------------------------------------------------------------------------    
        # (Step 1/11)
        # ----------------------------------------------------------------------------------------- 
        class2print = "MainProcess4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/11a) started" + "; init-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                 
                                        
        message2print = "{(Step 1/11b) borning" + "; mainprocess2xi-of-MainProcess4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                   

        message2print = "{(Step 1/11c) inheriting" + "; object-inheriting-by-mainprocess2xi-of-MainProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # object-inheriting-by-mainprocess2xi-of-MainProcess4Xi         
        
        message2print = "{(Step 1/11d) sharing" + "; Popen-sharing-by-mainprocess2xi-of-MainProcess4Xi: " + str(MainProcess4Xi._Popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                            
        # -----------------------------------------------------------------------------------------    
        # (Step 2/11)
        # ----------------------------------------------------------------------------------------- 
                        
        self._identity = ()


        message2print = "{(Step 2/11) set" + "; identity-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._identity)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # ()         
                
        # -----------------------------------------------------------------------------------------    
        # (Step 3/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._daemonic = False


        message2print = "{(Step 3/11) set" + "; daemonic-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # False 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 4/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._name = 'MainProcess4Xi'


        message2print = "{(Step 4/11) set" + "; name-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # MainProcess4Xi 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._parent_pid = None


        message2print = "{(Step 5/11) set" + "; parent-pid-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # None  
        
        # -----------------------------------------------------------------------------------------    
        # (Step 6/11)
        # -----------------------------------------------------------------------------------------                 
                         
        self._popen = None

        
        message2print = "{(Step 6/11) set" + "; popen-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # None  
        
        # -----------------------------------------------------------------------------------------    
        # (Step 7/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._counter = itertools.count(1) 

  
        message2print = "{(Step 7/11) set" + "; counter-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # count(1) 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 8/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._children = set()


        message2print = "{(Step 8/11) set" + "; children-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # set() 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 9/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._authkey = os.urandom(32) # becomes an instance of bytes class    


        message2print = "{(Step 9/11) set" + "; authkey-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #HW(str-version): b'}\x89q\xa8\xb5\xae\x81whR\x0crjVR\xafE\xa3\x13%\xdb{d\xc7\xff1\xdd\x95\xb6\x93re' <-- *** ERRONEOUS BECAUSE b'} IS INPRETED AS EMPTY DICTIONARY
        
        # -----------------------------------------------------------------------------------------    
        # (Step 10/11)
        # -----------------------------------------------------------------------------------------                 
         
        self._tempdir = tempfile.mkdtemp(prefix='pymp-')                 

        message2print = "{(Step 10/11) set" + "; tempdir-of-mainprocess2xi-set-by-init-of-MainProcess4Xi to: " + str(self._tempdir)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # c:\users\ceo4dr~1\appdata\local\temp\pymp-a6pe5h 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 11/11)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 11/11a) inherited" + "; object-inherited-by-mainprocess2xi-of-MainProcess4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        # class 'object'
        
        message2print = "{(Step 11/11b) activated" + "; mainprocess2xi-of-MainProcess4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # OK 
        
        message2print = "{(Step 11/11c) shared" + "; Popen-shared-by-mainprocess2xi-of-MainProcess4Xi: " + str(MainProcess4Xi._Popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                    
        message2print = "{(Step 11/11d) returning" + "; init-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # OK
  
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "run-of-MainProcess4Xi" usage = "to be run in sub-process; can be overridden in sub-class">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def run(self):
        '''
        to be run in sub-process; can be overridden in sub-class
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/3)
        # ------------------------------------------------------------------------------------- 
             
        class2print = "MainProcess4Xi"
        method2print = "run"
        
        message2print = "{(Step 1/3) started" + "; run-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
                        
      
        # -------------------------------------------------------------------------------------    
        # (Step 2/3)
        # ------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/3a) using" + "; target-of-mainprocess2xi-using-by-run-of-MainProcess4Xi: " + str(self._target)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                    
                   
        if self._target:
            try:
                         
            
                self._target(*self._args, **self._kwargs)
        
                message2print = "{(Step 2/3d) performed" + "; target-of-mainprocess2xi-performed-by-run-of-MainProcess4Xi to: " + str(self._target)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                message2print = "{(Step 2/3d) hit" + "; target-of-mainprocess2xi-hit-by-run-of-MainProcess4Xi: " + " *** " + str(self._target)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
        else:
            pass                            
        # -------------------------------------------------------------------------------------    
        # (Step 3/3)
        # ------------------------------------------------------------------------------------- 
        message2print = "{(Step 3/3) returning" + "; run-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
       
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "start-of-MainProcess4Xi" usage = "starts a child process">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def start(self):
        '''
        starts a child process
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/8)
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "start"
        
        message2print = "{(Step 1/8) started" + "; start-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   


        # -----------------------------------------------------------------------------------------    
        # (Step 2/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 2/8a) checking" + "; popen-of-mainprocess2xi-checking-by-start-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        if self._popen is None:
        
            message2print = "{(Step 2/8b) warning" + "; start-warning-by-start-of-MainProcess4Xi: " + " ** should not start a process twice ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                
        else:
        
            message2print = "{(Step 2/8c) commented" + "; starting-of-process-commented-by-start-of-MainProcess4Xi: ok = process has not yet been started " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
 
                        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 3/8a) got" + "; parent-pid-of-mainprocess2xi-got-by-start-of-MainProcess4Xi: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)

        
        message2print = "{(Step 3/8b) got" + "; pid-from-os-got-by-start-of-MainProcess4Xi: " + str(os.getpid())  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                        
        
        
        
        if self._parent_pid == os.getpid():        
        
            message2print = "{(Step 3/8c) warning" + "; pid-warning-by-start-of-MainProcess4Xi: " + " ** should only start a process object created by current process ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                
        else:
            message2print = "{(Step 3/8d) commented" + "; pid-of-process-commented-by-start-of-MainProcess4Xi: ok = process has not yet been started " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
   
             
        
                                
        # -----------------------------------------------------------------------------------------    
        # (Step 4/8)
        # -----------------------------------------------------------------------------------------                 
        
        # assert not _current_process._daemonic, \
        #        'daemonic processes are not allowed to have children'
        # message2print = "{(Step 3/7) asserted; assertion: " + "not daemonic a process (not allowed to have children)" + "; time: " + time4xi() + "}"
        # print4xi(class2print, method2print, message2print)         

        
        message2print = "{(Step 4/8) skipped" + "; Step-4-of-8-skipped-by-start-of-MainProcess4Xi: " + "* warning: not asserted a daemonic process with children *" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/8)
        # -----------------------------------------------------------------------------------------                 
        
        # _cleanup4xi()
     
        
        message2print = "{(Step 5/8) skipped" + "; Step-5-of-8-skipped-by-start-of-MainProcess4Xi: " + "* warning: not done _cleanup4xi *" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        
                
        # -----------------------------------------------------------------------------------------    
        # (Step 6/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 6/8a) analyzing" + "; Popen-of-mainprocess2xi-analyzing-by-start-of-MainProcess4Xi: " + str(self._Popen) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                
        if self._Popen is not None:
            try:
                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------                
                self._popen = self._Popen
                
                message2print = "{(Step 6/8b) set" + "; popen-of-mainprocess2xi-set-by-start-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                                
                message2print = "{(Step 6/8c) hit" + "; Popen-of-mainprocess2xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(self._Popen)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                              
                                                
                
        else:
            try:
                # ---------------------------------------------------------------------------------    
                #
                # ---------------------------------------------------------------------------------               
                message2print = "{(Step 6/8d) passing" + "; mainprocess2xi-passing-to-Popen4Xi-by-start-of-MainProcess4Xi: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            

                self._popen = Popen4Xi(self)
                
                message2print = "{(Step 6/8e) set" + "; popen-of-mainprocess2xi-set-by-start-of-MainProcess4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
            except:
                                
                message2print = "{(Step 6/8f) hit" + "; Popen4Xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(Popen4Xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                        
                
        
        # -----------------------------------------------------------------------------------------    
        # (Step 7/8)
        # -----------------------------------------------------------------------------------------                 
        try:        
            add_child_current_process4xi(self)
        
            message2print = "{(Step 7/8a) added; child-of-mainprocess2xi-added: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
        except:
            message2print = "{(Step 7/8b) hit" + "; add-child-current-process4xi-hit-by-start-of-MainProcess4Xi: " + " *** " + str(add_child_current_process4xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                            
        # -----------------------------------------------------------------------------------------    
        # (Step 8/8)
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 8/8) returning" + "; start-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                      
    #</methodize4xi>
     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "terminate-of-MainProcess4Xi" usage = "terminates process and sends SIGTERM signal or uses TerminateProcess">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def terminate(self):
        '''
        MainProcess4Xi terminate method: terminates process and sends SIGTERM signal or uses TerminateProcess
        '''

        # -------------------------------------------------------------------------------------    
        # (Step 1/3)
        # ------------------------------------------------------------------------------------- 
        class2print = "MainProcess4Xi"
        method2print = "terminate"
        
        message2print = "{(Step 1/3a) started" + "; terminate-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        if examine4xi(class2print, method2print):               
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
             
            message2print = "{(StepOriginal) calling" + "; Process-terminate-calling-by-terminate-of-MainProcess4Xi: " + str(Process.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
    
            Process.terminate(self)
            
            message2print = "{(StepOriginal) performed" + "; Process-terminate-performed-by-terminate-of-MainProcess4Xi: " + str(Process.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        else: 
                
            # -------------------------------------------------------------------------------------    
            # (Step 2/3)
            # ------------------------------------------------------------------------------------- 
             
            try:
                
                # -------------------------------------------------------------------------------------    
                #
                # ------------------------------------------------------------------------------------- 
                        
                self._popen.terminate()
               
                message2print = "{(Step 2/3a) performed" + "; popen-terminate-of-mainprocess2xi-performed-by-terminate-of-MainProcess4Xi: " + str(self._popen.terminate) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             

            except:
                
                # -------------------------------------------------------------------------------------    
                #
                # ------------------------------------------------------------------------------------- 
               
                message2print = "{(Step 2/3b) hit" + "; popen-terminate-of-mainprocess2xi-hit-by-terminate-of-MainProcess4Xi: " + " *** " + str(self._popen.terminate)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                    
                                           
        # -------------------------------------------------------------------------------------    
        # (Step 3/3)
        # ------------------------------------------------------------------------------------- 
                          
        message2print = "{(Step 3/3) returning" + "; terminate-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 

    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "join-of-MainProcess4Xi" usage = "waits until child process terminates">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def join(self, timeout=None):
        '''
        waits until child process terminates
        ''' 

        # -------------------------------------------------------------------------------------    
        # (Step 1/7)
        # ------------------------------------------------------------------------------------- 
        class2print = "MainProcess4Xi"
        method2print = "join"
        
        message2print = "{(Step 1/7a) started" + "; join-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        timeout = omega2timeout4xi(class2print, method2print) 

        message2print = "{(Step 1/7b)  set" + "; timeout-set-by-join-of-MainProcess4Xi to: " + str(timeout)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        if examine4xi(class2print, method2print):             
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
           
            message2print = "{(StepOriginal) calling" + "; Process-join-calling-by-join-of-MainProcess4Xi: " + str(Process.join) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)               
                
            message2print = "{(StepOriginal) passing" + "; timeout-passing-to-Process-join-by-join-of-MainProcess4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
                          
            Process.join(self, timeout)
    
            message2print = "{(StepOriginal) performed" + "; Process-join-performed-by-join-of-MainProcess4Xi: " + str(Process.join) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             

        else:
                
            # -------------------------------------------------------------------------------------    
            # (Step 2/7)
            # ------------------------------------------------------------------------------------- 
            message2print = "{(Step 2/7) analyzing" + "; parent-pid-of-mainprocess2xi-analyzing-by-join-of-MainProcess4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
           
            if self._parent_pid == os.getpid():
                
                # -------------------------------------------------------------------------------------    
                #(Step 3/7)
                # ------------------------------------------------------------------------------------- 
                message2print = "{(Step 3/7) analyzing" + "; popen-of-mainprocess2xi-analyzing-by-join-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                                   
                if self._popen is not None:
                
                    # ---------------------------------------------------------------------------------    
                    # (Step 4/7)
                    # --------------------------------------------------------------------------------- 
                    message2print = "{(Step 4/7a) passing" + "; timeout-passing-to-popen-wait-of-mainprocess2xi-by-join-of-MainProcess4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)            
                    
                    res2xi = self._popen.wait(timeout)

                    message2print = "{(Step 4/7b) set" + "; res2xi-set-by-join-of-MainProcess4Xi to: " + str(res2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                                    
                    if res2xi is not None:
                        message2print = "{(Step 4/7c) passing" + "; mainprocess2xi-passing-to-discard-of-current-process-by-join-of-MainProcess4Xi: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)                      
                    
                        _current_process._children.discard(self)
                    else:
                        pass
                else:
                
                    # ---------------------------------------------------------------------------------    
                    # (Step 5/7)
                    # --------------------------------------------------------------------------------- 
                      
                    message2print = "{(Step 5/7) warned" + "; popen-of-mainprocess2xi-warned-by-join-of-MainProcess4Xi: " + " ** can only join a started process ** " + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                             
        
            else:
                
                # -------------------------------------------------------------------------------------    
                # (Step 6/7)
                # ------------------------------------------------------------------------------------- 
                 
                message2print = "{(Step 6/7) warned" + "; pid-warned-by-join-of-MainProcess4Xi: " + " ** can only join a child process ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)               
                                
                
        # -------------------------------------------------------------------------------------    
        # (Step 7/7)
        # ------------------------------------------------------------------------------------- 
                        
        message2print = "{(Step 7/7) returning" + "; join-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                        
                        
    #</methodize4xi>
                          
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "is-alive-of-MainProcess4Xi" usage = "returns whether process is alive">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def is_alive(self):
        '''
        returns whether process is alive
        '''
        
        # -------------------------------------------------------------------------------------    
        # (Step 1/5) 
        # ------------------------------------------------------------------------------------- 
               
        class2print = "MainProcess4Xi"
        method2print = "is_alive"
         
        message2print = "{(Step 1/5a) started" + "; is-alive-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        if examine4xi(class2print, method2print):            
                
            # -------------------------------------------------------------------------------------    
            #
            # ------------------------------------------------------------------------------------- 
        
            message2print = "{(StepOriginal) passing" + "; mainprocess2xi-passing-to-Process-is-alive: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
      
            message2print = "{(StepOriginal) returning" + "; Process-is-alive-returning-by-is-alive-of-MainProcess4Xi: " + str(Process.is_alive) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  

            return Process.is_alive(self)
        else:
                
            # -------------------------------------------------------------------------------------    
            # (Step 1/4)
            # ------------------------------------------------------------------------------------- 
            alive2xi = False                                         # default status is noy alive
            
            ack2current = False
            nack2current = True
                
            # -------------------------------------------------------------------------------------    
            # (Step 2/4)
            # ------------------------------------------------------------------------------------- 
            try:    
                if self is get_current_process4xi():
                    # -----------------------------------------------------------------------------    
                    # this is the current process object
                    # -----------------------------------------------------------------------------                 
                    alive2xi = True
                    
                    message2print = "{(Step 2/4a) set" + "; alive2xi-set-by-is-alive-of-MainProcess4Xi to: " + str(alive2xi)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                  
                    ack2current = True
                    nack2current = False
                else:
                    # -----------------------------------------------------------------------------    
                    # this is NOT the current process object
                    # -----------------------------------------------------------------------------                  
                    pass    
                    
            except:
                message2print = "{(Step 2/4b) yielded" + "; nack2current-yielded-by-is-alive-of-MainProcess4Xi: " + str(nack2current)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
               
            # -------------------------------------------------------------------------------------    
            #(Step 3/5)
            # ------------------------------------------------------------------------------------- 
            ack2child = False
            nack2child = True
            
            if ack2current is True:
                # ---------------------------------------------------------------------------------    
                # this was the current process object and therefore is alive
                # ---------------------------------------------------------------------------------             
                pass
            else:
                # ---------------------------------------------------------------------------------    
                # we need to continue finding out whether it is alive or not
                # ---------------------------------------------------------------------------------                   
                if self._parent_pid == os.getpid(): 
                
                    # -----------------------------------------------------------------------------    
                    # testing a child process
                    # -----------------------------------------------------------------------------               
                    ack2child = True
                    nack2child = False
                    
                    ack2popen = False                    
                    nack2popen = True
                    
                    try:
                        # -------------------------------------------------------------------------    
                        # 
                        # -------------------------------------------------------------------------                      
                        if self._popen is None:
                            # ---------------------------------------------------------------------    
                            # no child openened
                            # ---------------------------------------------------------------------                       
                            alive2xi = False                         # not alive
                            
                            message2print = "{(Step 3/5a) set" + "; alive2xi-set-by-is-alive-of-MainProcess4Xi to: " + str(alive2xi)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)    
                            
                            ack2popen = True                         
                            nack2popen = False 
                             
                       
                        else:
                            # ---------------------------------------------------------------------    
                            # poll child 
                            # ---------------------------------------------------------------------                     
                            self._popen.poll()
                    
                            message2print = "{(Step 3/5b) performed" + "; popen-poll-of-mainprocess2xi-performed-by-is-alive-of-MainProcess4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)             
                                
                            # -------------------------------------------------------------------------    
                            # check return code 
                            # -------------------------------------------------------------------------                
                            alive2xi = self._popen.returncode is None
                            
                            message2print = "{(Step 3/5c) set" + "; alive2xi-set-by-is-alive-of-MainProcess4Xi to: " + str(alive2xi)  + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)    
                            
                        # -------------------------------------------------------------------------    
                        # 
                        # -------------------------------------------------------------------------                               
                            
                    except:
                        message2print = "{(Step 3/5d) yielded" + "; nack2popen-yielded-by-is-alive-of-MainProcess4Xi: " + str(nack2popen)  + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)             
                else:
                    # -----------------------------------------------------------------------------    
                    # 
                    # -----------------------------------------------------------------------------                    
                    message2print = "{(Step 3/5e) yielded" + "; nack2child-yielded-by-is-alive-of-MainProcess4Xi: " + str(nack2child)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                

            # -------------------------------------------------------------------------------------    
            #
            #(Step 5/5)
            # ------------------------------------------------------------------------------------- 
      
            return alive2xi
            
            
    #</methodize4xi>
                


    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-of-MainProcess4Xi" usage = "returns process name">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def name(self):
        '''
        Process4Xi name method: returns process name
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "name"
        
        message2print = "{started" + "; name-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                         
        message2print = "{returning" + "; name-of-mainprocess2xi-returning-by-name-of-MainProcess4Xi: " + str(self._name) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                        
        
        return self._name
        
    #</methodize4xi>
       
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-of-MainProcess4Xi" usage = "sets process name">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @name.setter
    def name(self, name):
        '''
        MainProcess4Xi name method: sets process name 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "name"
        
        message2print = "{started" + "; name-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        message2print = "{passed" + "; name-passed-to-name-of-MainProcess4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        self._name = name

        message2print = "{set" + "; name-of-mainprocess2xi-set-by-name-of-MainProcess4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{returning" + "; name-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #hw: 

                        
                       
                
                                   
    #</methodize4xi>
     
        
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-of-MainProcess4Xi" usage = "returns whether process is a daemon">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def daemon(self):
        '''
        MainProcess4Xi daemon method: returns whether process is a daemon
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        message2print = "{returning" + "; daemonic-of-mainprocess2xi-returning-by-daemon-of-MainProcess4Xi: " + str(self._daemonic) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                         
        
        return self._daemonic
    #</methodize4xi>
            
           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-of-MainProcess4Xi" usage = "sets process daemonic">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @daemon.setter
    def daemon(self, daemonic):
        '''
        MainProcess4Xi daemon method: sets process daemonic
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        message2print = "{passed" + "; daemonic-passed-to-daemon-of-MainProcess4Xi: " + str(daemonic) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
    
        message2print = "{passing" + "; daemonic-passing-to-Process-daemon-by-daemon-of-MainProcess4Xi: " + str(daemonic) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #hw: 
        
                
        self._daemonic = Process.daemon(self, daemonic)   
    
        message2print = "{set" + "; daemonic-of-mainprocess2xi-set-by-daemon-of-MainProcess4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
    
        message2print = "{returning" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        #hw: 
        
    #</methodize4xi>
                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-of-MainProcess4Xi" usage = "returns authorization key">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def authkey(self):
        '''
        MainProcess4Xi authkey method: returns authorization key
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "authkey"
        
        message2print = "{started" + "; authkey-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
      
        message2print = "{returning" + "; authkey-of-mainprocess2xi-returning-by-authkey-of-MainProcess4Xi: " + str(self._authkey) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                        
        
        return self._authkey
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-of-MainProcess4Xi" usage = "sets authorization key">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @authkey.setter
    def authkey(self, authkey):
        '''
        MainProcess4Xi authkey method: sets authorization key
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "authkey"        
        
        
        message2print = "{started" + "; authkey-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        message2print = "{passed" + "; authkey-passed-to-authkey-of-MainProcess4Xi: " + str(authkey) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
       
        
        self._authkey = authkey #dragonized 
            
        message2print = "{set" + "; authkey-of-mainprocess2xi-set-by-authkey-of-MainProcess4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
                    
        message2print = "{returning" + "; authkey-of-MainProcess4Xi-returning: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                        
          
    #</methodize4xi>
         
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "exitcode-of-MainProcess4Xi" usage = "returns exit code of process or None if it has yet to stop">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def exitcode(self):
        '''
        MainProcess4Xi exicode method: returns exit code of process or `None` if it has yet to stop
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "exitcode"
        
        message2print = "{started" + "; exitcode-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        message2print = "{got" + "; popen-of-mainprocess2xi-got-by-exitcode-of-MainProcess4Xi: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
                    
        if self._popen is None:
        
            message2print = "{returning" + "; popen-of-mainprocess2xi-returning-by-exitcode-of-MainProcess4Xi: " + str(self._popen) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            #hw: 
            
                           
               
            return self._popen
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        message2print = "{returning" + "; popen-poll-function-of-mainprocess2xi-returning-by-exitcode-of-MainProcess4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        #hw: 
        
                  
        
        return self._popen.poll()       
    #</methodize4xi>
      
               
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ident-of-MainProcess4Xi" usage = "returns indentifier (PID) of process or None if it has yet to start">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def ident(self):
        '''
        MainProcess4Xi ident method: returns indentifier (PID) of process or `None` if it has yet to start
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "ident"
        
        message2print = "{started" + "; ident-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
      
        message2print = "{returning" + "; Process-ident-method-returning-by-ident-of-MainProcess4Xi: " + str(Process.ident) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        #hw: 
        
                      
 
        return Process.ident(self)
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-MainProcess4Xi" usage = "presentation of MainProcess4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        MainProcess4Xi __repr__ method: 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "__repr__"

        # -----------------------------------------------------------------------------------------    
        # Step 1/7 
        # -----------------------------------------------------------------------------------------                 
                
        message2print = "{(Step 1/7) started" + "; repr-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw:{ MainProcess4Xi : __repr__ ; (Step 1/7) started; repr-of-MainProcess4Xi-started: 09:15:23 01/11/10 FLE Standard Time} 
        


       
        # -----------------------------------------------------------------------------------------    
        # Step 2/7 - None; no parent exists for this process
        # -----------------------------------------------------------------------------------------                 
            
        message2print = "{(Step 2/7) got" + "; parent-pid-of-mainprocess2xi-got-by-repr-of-MainProcess4Xi: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw:{ MainProcess4Xi : __repr__ ; (Step 2/7) got; parent-pid-got-by-repr-of-MainProcess4Xi: None; time: 09:15:23 01/11/10 FLE Standard Time} 
        

        
        
        # -----------------------------------------------------------------------------------------    
        # Step 3/7 - integer value
        # -----------------------------------------------------------------------------------------                 
 
        ospid2xi = os.getpid()
        
          
        message2print = "{(Step 3/7) got" + "; ospid2xi-got-by-repr-of-MainProcess4Xi: " + str(ospid2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #hw:{ MainProcess4Xi : __repr__ ; (Step 3/7) got; ospid2xi-got-by-repr-of-MainProcess4Xi: 3432; time: 09:15:23 01/11/10 FLE Standard Time} 
        

        
        # -----------------------------------------------------------------------------------------    
        # Step 4/7
        # -----------------------------------------------------------------------------------------                 
            
        message2print = "{(Step 4/7) got" + "; popen-of-mainprocess2xi-got-by-repr-of-MainProcess4Xi: " + str(self._popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: { MainProcess4Xi : __repr__ ; (Step 4/7) got; popen-got-by-repr-of-MainProcess4Xi: None; time: 09:15:23 01/11/10 FLE Standard Time}
        

        
         
        # -----------------------------------------------------------------------------------------    
        # Step 5/7 - skipped - not possible!
        # -----------------------------------------------------------------------------------------                 
        # poll2xi = self._popen.poll()
            
        message2print = "{(Step 5/7) skipped" + "; Step-5-of-7-skipped-by-repr-of-MainProcess4Xi: " + "*** to-be-done: poll2xi = self._popen.poll() ***"  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        #hw: { MainProcess4Xi : __repr__ ; (Step 5/7) skipped; Step-5-of-7-skipped-by-repr-of-MainProcess4Xi: *** to-be-done: poll2xi = self._popen.poll() ***; time: 09:15:23 01/11/10 FLE Standard Time}
        
    
        # -----------------------------------------------------------------------------------------    
        # Step 6/7
        # -----------------------------------------------------------------------------------------                 
    
                
        r2xi = Process.__repr__(self)
        
        message2print = "{(Step 6/7a) do" + "; Step-6-of-7-do-by-repr-of-MainProcess4Xi: " + "** to-be-done: (Step 6/7a) r2xi = Process.__repr__(self) **" + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw:{ MainProcess4Xi : __repr__ ; (Step 6/7a) do; Step-6-of-7-do-by-repr-of-MainProcess4Xi: ** to-be-done: (Step 6/7a) r2xi = Process.__repr__(self) **; time: 09:15:23 01/11/10 FLE Standard Time} 
        #to be solved: calling original is not the solution because it uses _current_process of standard multiprocessing !                
        
        message2print = "{(Step 6/7b) got" + "; r2xi-got-by-repr-of-MainProcess4Xi: " + str(r2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #hw:{ MainProcess4Xi : __repr__ ; (Step 6/7b) got; r2xi-got-by-repr-of-MainProcess4Xi: <MainProcess4Xi(MainProcess4Xi, unknown)>; time: 09:15:23 01/11/10 FLE Standard Time} 
        
        
        # -----------------------------------------------------------------------------------------    
        # Step 7/7
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 7/7) returning" + "; r2xi-returning-by-repr-of-MainProcess4X: " + str(r2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw:{ MainProcess4Xi : __repr__ ; (Step 7/7) returning; r2xi-returning-by-repr-of-MainProcess4X: <MainProcess4Xi(MainProcess4Xi, unknown)>; time: 09:15:23 01/11/10 FLE Standard Time} 
        
                                
       

        
        return r2xi      
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "bootstrap-of-MainProcess4Xi" usage = "bootstrap">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    #
    def _bootstrap(self):
        '''
        MainProcess4Xi _bootstrap method: bootstrap; defines global objects
        ''' 
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        class2print = "MainProcess4Xi"
        method2print = "_bootstrap"
        
        message2print = "{started" + "; bootstrap-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
  
        message2print = "{passing" + "; mainprocess2xi-passing-to-Process-bootstrap-by-bootstrap-of-MainProcess4Xi: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        #hw: 
        
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
            
        message2print = "{returning" + "; Process-bootstrap-method-returning-by-bootstrap-of-MainProcess4Xi: " + str(Process._bootstrap) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        #hw: 
        
                                
        return Process._bootstrap(self)
        
    #</methodize4xi>
    
        
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MainProcess4Xi" usage = "senses MainProcess4X class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses MainProcess4X class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
     
        
        class2print = 'MapResult4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
       
        message2print = "{sensing" + "; MapResult4Xi-sensing-by-sense-of-MainProcess4Xi: " + str(MapResult4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #hw: 
        
                        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['Popen-of-MainProcess4Xi'] = MainProcess4Xi._Popen
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-MainProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
        
      
        message2print = "{sensed" + "; MapResult4Xi-sensed-by-sense-of-MainProcess4Xi: " + str(MapResult4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-MainProcess4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                                   
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MainProcess4Xi" usage = "reasons MainProcess4X class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons MainProcess4X class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
           
        
        class2print = 'MapResult4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; MapResult4Xi-reasoning-by-reason-of-MainProcess4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-MainProcess4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        message2print = "{reasoned" + "; MapResult4Xi-reasoned-by-reason-of-MainProcess4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-MainProcess4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                        
                           
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MainProcess4Xi" usage = "aces MainProcess4X class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces MainProcess4X class objects 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # ------------------------------------------------------------------------------------- 
         
        
        
        class2print = 'MapResult4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-MainProcess4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; MapResult4Xi-acing-by-ace-of-MainProcess4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        #hw: 
        
                   
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-MainProcess4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        #hw: 
        
                

        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; MapResult4Xi-aced-by-ace-of-MainProcess4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        #hw: 
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-MainProcess4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        #hw: 
        
                         
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#HW:
#   test_hello_world4xi.txt
#   sense-test-hello-world4xi.xml
#   reason-test-hello-world4xi.xml
#   ace-test-hello-world4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of mainprocess4Xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

